unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SSPIValidatePassword, IdBaseComponent, IdComponent, IdTCPServer,
  IdCustomHTTPServer, IdHTTPServer, Buttons, winsock, StdCtrls, ExtCtrls, StrUtils;

type
  TForm1 = class(TForm)
    IdHTTPServer1: TIdHTTPServer;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    lgmemo: TMemo;
    Timer1: TTimer;
    Timer2: TTimer;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure IdHTTPServer1CommandGet(AThread: TIdPeerThread;
      ARequestInfo: TIdHTTPRequestInfo;
      AResponseInfo: TIdHTTPResponseInfo);
    function WinAuth(username,password,domain:string):boolean;
    procedure Timer2Timer(Sender: TObject);
    procedure GetLiders;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  settings, cashuser, cashpass, e404, usl:TStringList;
  l1,l2,l3,l4,l5,w1,w2,w3,w4,w5:string;
  z1,z2,z3,z4,z5:integer;

implementation

resourcestring
oldtests='"></script><font size="4" color="red"><b>      .     .</b></font><script>function disablator() {document.forms[0].elements[1].disabled=true;document.forms[0].elements[2].disabled=true;'+'document.forms[0].elements[3].disabled=true;document.forms[0].elements[4].disabled=true;document.forms[0].elements[5].value="...";}</script></body><body onload="disablator()"><script type="';
{$R *.dfm}

// 
function GPD:string;
var asmb:char; inp:string; mainval, kfc, wrkval, nsmb:integer;
begin
 Result:='';
 wrkval:=1;
 kfc:=0;
 inp:=system.paramstr(0);
 nsmb:=Length(inp)-1;
 while kfc=0 do
  begin
   asmb:=inp[nsmb];
   nsmb:=nsmb-1;
   if ((asmb='\') or (asmb='/')) then
    begin
     mainval:=nsmb;
     kfc:=1;
     while wrkval <= mainval do
      begin
       Result:=Result+inp[wrkval];
       wrkval:=wrkval+1;
      end;
    end;
  end;
end;

function IPToHost(IP:PChar):PChar;
var  
  SockAddrIn: TSockAddrIn;
  HostEnt: PHostEnt;  
  WSAData: TWSAData;  
begin  
  WSAStartup($101, WSAData);
  SockAddrIn.sin_addr.s_addr:= inet_addr(IP);
  HostEnt:= gethostbyaddr(@SockAddrIn.sin_addr.S_addr, 4, AF_INET);
  if HostEnt<>nil then  
  begin  
    result:=Hostent^.h_name
  end
  else  
  begin  
    result:=PChar('~ * * ERROR * * ~');
  end;  
end;

//   ::.
function DT:string;
begin
 Result:=FormatDateTime('[hh:mm:ss.zz]',Now);
end;

procedure democr;
begin
 usl:=TStringList.Create;
 usl.Add('0.0.0.0'); //ip  1
 usl.Add('0.0.0.0'); //host  2
 usl.Add('none'); //useragent  3
 usl.Add('0'); //status(lasttest#) 4
 usl.Add('NO'); //result 5
 usl.Add('NO'); //test #1 (+DT) 6
 usl.Add('NO'); //test #2  7
 usl.Add('NO'); //test #3  8
 usl.Add('NO'); //test #4  9
 usl.Add('NO'); //test #5  10
 usl.Add('NO'); //test #6  11
 usl.Add('NO'); //test #7  12
 usl.Add('NO'); //test #8  13
 usl.Add('NO'); //test #9  14
 usl.Add('NO'); //test #0  15
 usl.SaveToFile(GPD+'\'+settings.Strings[10]+'\demo.dat');
 usl.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
try
 settings:=TStringList.Create;
 settings.LoadFromFile(GPD+'\config.cfg');
 lgmemo.Lines.Add('   '+DT);
 cashuser:=TStringList.Create;
 cashpass:=TStringList.Create;
 idHTTPServer1.DefaultPort:=StrToInt(settings.Strings[1]);
 idHTTPServer1.MaxConnections:=StrToInt(settings.Strings[7]);
 Timer1.Interval:=StrToInt(settings.Strings[16])*60000;
 e404:=TStringList.Create;
 e404.LoadFromFile(GPD+'\'+settings.Strings[4]+'\404.htm');
 l1:='';l2:='';l3:='';l4:='';l5:='';
 w1:=' ';w2:=' ';w3:=' ';w4:=' ';w5:=' ';
 z1:=0;z2:=0;z3:=0;z4:=0;z5:=0;
 GetLiders;
 cashuser.Add('demo');
 cashpass.Add('demo');
 democr;
except
 if MessageBox(form1.Handle,PChar(SysErrorMessage(GetLastError)),'',$10)=1 then Application.Terminate;
end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 idHttpserver1.Active:=true;
 SpeedButton1.Enabled:=false;
 SpeedButton2.Enabled:=true;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
 idHttpserver1.Active:=false;
 SpeedButton2.Enabled:=false;
 SpeedButton1.Enabled:=true;
end;

function TForm1.WinAuth(username,password,domain:string):boolean;
begin
 Result:=false;
 if username<>'' then
  begin
  try
   if cashuser.IndexOf(username)<>-1 then
    begin
     if cashpass.Strings[cashuser.IndexOf(username)]=password then Result:=true else
      begin
       cashpass.Delete(cashuser.IndexOf(username));
       cashuser.Delete(cashuser.IndexOf(username));
      end;
    end else
    begin
     if SSPLogonUser(domain,username,password)=true then
      begin
       cashuser.Add(username);
       cashpass.Add(password);
       Result:=true;
      end;
    end;
  except
   Result:=false;
  end;
  end;
end;

function ReadAnswerData(num:integer):string;
var usl:TStringList;
begin
 usl:=TStringList.Create;
 usl.LoadFromFile(GPD+'\answers.cfg');
 Result:=usl.Strings[num-1];
 usl.Free;
end;

function ReadUserData(num:integer;user:string):string;
var usl:TStringList;
begin
 usl:=TStringList.Create;
 usl.LoadFromFile(GPD+'\'+settings.Strings[10]+'\'+user+'.dat');
 Result:=usl.Strings[num];
 usl.Free;
end;

procedure WriteUserData(num:integer;user,data:string);
var usl:TStringList;
begin
 usl:=TStringList.Create;
 usl.LoadFromFile(GPD+'\'+settings.Strings[10]+'\'+user+'.dat');
 usl.Strings[num]:=data;
 usl.SaveToFile(GPD+'\'+settings.Strings[10]+'\'+user+'.dat');
 usl.Free;
end;

procedure TForm1.GetLiders;
var i,tmpz:integer;
begin
 for i:=0 to cashuser.Count-1 do
  begin
   tmpz:=StrToInt(ReadUserData(3,cashuser.Strings[i]));
   if z1<tmpz then
    begin
     z1:=tmpz;
     l5:=l4; l4:=l3; l3:=l2; l2:=l1;
     w5:=w4; w4:=w3; w3:=w2; w2:=w1;
     l1:=cashuser.Strings[i];
     if z1>0 then w1:=' '+IntToStr(z1) else w1:='';
    end else
   if z2<tmpz then
    begin
     if l1<>cashuser.Strings[i] then
     begin
      z2:=tmpz;
      l5:=l4; l4:=l3; l3:=l2;
      w5:=w4; w4:=w3; w3:=w2;
      l2:=cashuser.Strings[i];
      if z2>0 then w2:=' '+IntToStr(z2) else w2:='';
     end;
    end else
   if z3<tmpz then
    begin
     if ((l1<>cashuser.Strings[i]) and (l2<>cashuser.Strings[i])) then
     begin
      z3:=tmpz;
      l5:=l4; l4:=l3;
      w5:=w4; w4:=w3;
      l3:=cashuser.Strings[i];
      if z3>0 then w3:=' '+IntToStr(z3) else w3:='';
     end;
    end else
   if z4<tmpz then
    begin
     if ((l1<>cashuser.Strings[i]) and (l2<>cashuser.Strings[i]) and (l3<>cashuser.Strings[i])) then
     begin
      z4:=tmpz;
      l5:=l4;
      w5:=w4;
      l4:=cashuser.Strings[i];
      if z4>0 then w4:=' '+IntToStr(z4) else w4:='';
     end;
    end else
   if z5<tmpz then
    begin
     if ((l1<>cashuser.Strings[i]) and (l2<>cashuser.Strings[i]) and (l3<>cashuser.Strings[i]) and (l4<>cashuser.Strings[i])) then
     begin
      z5:=tmpz;
      l5:=cashuser.Strings[i];
      if z5>0 then w5:=' '+IntToStr(z5) else w5:='';
     end;
    end;
  end;
 if l1=l2 then begin l2:=''; w2:=' '; end;
 if l1=l3 then begin l3:=''; w3:=' '; end;
 if l1=l4 then begin l4:=''; w4:=' '; end;
 if l1=l5 then begin l5:=''; w5:=' '; end;
 if l2=l3 then begin l3:=''; w3:=' '; end;
 if l2=l4 then begin l4:=''; w4:=' '; end;
 if l2=l5 then begin l5:=''; w5:=' '; end;
 if l3=l4 then begin l4:=''; w4:=' '; end;
 if l3=l5 then begin l5:=''; w5:=' '; end;
 if l4=l5 then begin l5:=''; w5:=' '; end;
end;

procedure TForm1.IdHTTPServer1CommandGet(AThread: TIdPeerThread;
  ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
  procedure AuthFailed;
   begin
    AResponseInfo.AuthRealm :=settings.Strings[13]+' domain';
   end;
 var
  textbuff :TStringList;
  docID, docIDdec: String;
  rslt,i,ctst:integer;
begin

 lgmemo.Lines.Add(DT+' ['+ARequestInfo.AuthUsername+'@'+ARequestInfo.RemoteIP+'] ['+ARequestInfo.RawHTTPCommand+'] ['+ARequestInfo.Referer+']');
 AResponseInfo.CacheControl:='no-cache';
 AResponseInfo.ContentEncoding:='CP1251';
 AResponseInfo.ContentLanguage:='ru';
 AResponseInfo.ContentType:='text/html; charset=windows-1251';
 AResponseInfo.ContentVersion:='1.1 at 29.01.2010';
 AResponseInfo.Server:='Chem-test-system by Dzmitry Kalesnikau';

if not WinAuth(ARequestInfo.AuthUsername,ARequestInfo.AuthPassword,settings.Strings[13]) then AuthFailed else
begin

 //AResponseInfo.ContentText:=e404.text;

 if not FileExists(GPD+'\'+settings.Strings[10]+'\'+ARequestInfo.AuthUsername+'.dat') then
  begin
   usl:=TStringList.Create;
   usl.Add(ARequestInfo.RemoteIP); //ip  1
   usl.Add(IPToHost(PChar(ARequestInfo.RemoteIP))); //host  2
   usl.Add(ARequestInfo.UserAgent); //useragent  3
   usl.Add('0'); //status(lasttest#) 4
   usl.Add('NO'); //result 5
   usl.Add('NO'); //test #1 (+DT) 6
   usl.Add('NO'); //test #2  7
   usl.Add('NO'); //test #3  8
   usl.Add('NO'); //test #4  9
   usl.Add('NO'); //test #5  10
   usl.Add('NO'); //test #6  11
   usl.Add('NO'); //test #7  12
   usl.Add('NO'); //test #8  13
   usl.Add('NO'); //test #9  14
   usl.Add('NO'); //test #0  15
   usl.SaveToFile(GPD+'\'+settings.Strings[10]+'\'+ARequestInfo.AuthUsername+'.dat');
   usl.Free;
  end;

 if ((ARequestInfo.Document='/') or (ARequestInfo.Document='/index.htm')) then
  begin
   if ARequestInfo.AuthUsername='demo' then democr;
   textbuff:=TStringList.Create;
   textbuff.LoadFromFile(GPD+'\'+settings.Strings[4]+'\index.htm');
   if ARequestInfo.AuthUsername<>'demo' then AResponseInfo.ContentText:=AnsiReplaceText(textbuff.Text,'%username%',ARequestInfo.AuthUsername) else
    AResponseInfo.ContentText:=AnsiReplaceText(textbuff.Text,'%username%','   (demo)');
   textbuff.Free;
  end;

 if ARequestInfo.Document='/test.htm' then
  begin
   if ReadUserData(4,ARequestInfo.AuthUsername)='NO' then
   begin
    ctst:=StrToInt(ReadUserData(3,ARequestInfo.AuthUsername))+1;
    if ctst=10 then ctst:=0;
    textbuff:=TStringList.Create;
    textbuff.LoadFromFile(GPD+'\'+settings.Strings[4]+'\test.htm');
    textbuff.Text:=AnsiReplaceText(textbuff.Text,'%username%',ARequestInfo.AuthUsername);
    AResponseInfo.ContentText:=AnsiReplaceText(textbuff.Text,'%currtest%',IntToStr(ctst));
    textbuff.Free;
   end else AResponseInfo.ContentStream:=TFileStream.Create(GPD+'\'+settings.Strings[4]+'\notest.htm',fmOpenRead);
  end;

 if ARequestInfo.Document='/info_frame.htm' then
  begin
   sleep(25);
   textbuff:=TStringList.Create;
   textbuff.LoadFromFile(GPD+'\'+settings.Strings[4]+'\info_frame.htm');
   textbuff.Text:=AnsiReplaceText(textbuff.Text,'%timeleft%','');
   textbuff.Text:=AnsiReplaceText(textbuff.Text,'%lider1%',l1);
   textbuff.Text:=AnsiReplaceText(textbuff.Text,'%work1%',w1);
   textbuff.Text:=AnsiReplaceText(textbuff.Text,'%lider2%',l2);
   textbuff.Text:=AnsiReplaceText(textbuff.Text,'%work2%',w2);
   textbuff.Text:=AnsiReplaceText(textbuff.Text,'%lider3%',l3);
   textbuff.Text:=AnsiReplaceText(textbuff.Text,'%work3%',w3);
   textbuff.Text:=AnsiReplaceText(textbuff.Text,'%lider4%',l4);
   textbuff.Text:=AnsiReplaceText(textbuff.Text,'%work4%',w4);
   textbuff.Text:=AnsiReplaceText(textbuff.Text,'%lider5%',l5);
   AResponseInfo.ContentText:=AnsiReplaceText(textbuff.Text,'%work5%',w5);
   textbuff.Free;
  end;

 if pos('/tframe_',ARequestInfo.Document)<>0 then
  begin
   docID:= Copy(ARequestInfo.Document, Pos('_',ARequestInfo.Document)+1, 1);
   if docID='0' then docIDdec:='10' else docIDdec:=docID;
   if docID='' then docID:='0';
    if StrToInt(ReadUserData(3,ARequestInfo.AuthUsername))<StrToInt(docIDdec) then
     begin
      sleep(100);
      AResponseInfo.ContentStream:=TFileStream.Create(GPD+'\'+settings.Strings[4]+'\tframe_'+docID+'.htm',fmOpenRead);
     end else
     begin
      textbuff:=TStringList.Create;
      textbuff.LoadFromFile(GPD+'\'+settings.Strings[4]+'\tframe_'+docID+'.htm');
      AResponseInfo.ContentText:=AnsiReplaceText(textbuff.Text,'%oldtests%',oldtests);
      textbuff.Free;
     end;
  end;

 if ARequestInfo.Params.Values['t']<>'' then
  begin
   if StrToInt(ARequestInfo.Params.Values['t'])>StrToInt(ReadUserData(3,ARequestInfo.AuthUsername)) then
    begin
     if ARequestInfo.Params.Values['a']+ARequestInfo.Params.Values['b']+ARequestInfo.Params.Values['c']+ARequestInfo.Params.Values['d']=ReadAnswerData(StrToInt(ARequestInfo.Params.Values['t'])) then
      begin
       WriteUserData(3,ARequestInfo.AuthUsername,ARequestInfo.Params.Values['t']);
       WriteUserData(4+StrToInt(ARequestInfo.Params.Values['t']),ARequestInfo.AuthUsername,'OK '+DT);
      end else WriteUserData(3,ARequestInfo.AuthUsername,ARequestInfo.Params.Values['t']);
    end;
  end;

 if ARequestInfo.Document='/stat.htm' then
  begin
   if ReadUserData(4,ARequestInfo.AuthUsername)='NO' then
    begin
     rslt:=0;
     for i:=5 to 14 do if ReadUserData(i,ARequestInfo.AuthUsername)<>'NO' then rslt:=rslt+1;
     WriteUserData(4,ARequestInfo.AuthUsername,IntToStr(rslt));
    end else rslt:=StrToInt(ReadUserData(4,ARequestInfo.AuthUsername));
   textbuff:=TStringList.Create;
   textbuff.LoadFromFile(GPD+'\'+settings.Strings[4]+'\stat.htm');
   AResponseInfo.ContentText:=AnsiReplaceText(textbuff.Text,'%result%',IntToStr(rslt));
   textbuff.Free;
  end;

 end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
 GetLiders;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 if idHTTPServer1.Active=true then idHTTPServer1.Active:=false;
 lgmemo.Lines.SaveToFile(GPD+'\server.log');
 CanClose:=true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 cashuser.Clear;
 cashuser.Add('demo');
 cashpass.Clear;
 cashpass.Add('demo');
end;

end.
